unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdAntiFreezeBase, IdAntiFreeze, IdCoder, IdCoder3to4,
  IdCoderMIME, IdMessage, IdSMTP, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdMessageClient, IdPOP3, StdCtrls, ComCtrls,
  Grids;

type
  TForm1 = class(TForm)
    ListView1: TListView;
    ListView2: TListView;
    RichEdit1: TRichEdit;
    Button1: TButton;
    Button2: TButton;
    IdPOP31: TIdPOP3;
    IdSMTP1: TIdSMTP;
    IdMessage1: TIdMessage;
    IdEncoderMIME1: TIdEncoderMIME;
    IdAntiFreeze1: TIdAntiFreeze;
    Button3: TButton;
    Label1: TLabel;
    Button4: TButton;
    Label2: TLabel;
    IdDeMIME: TIdDecoderMIME;
    SaveDialog1: TSaveDialog;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);


    procedure down(Sender: TObject);
    
    function Base64Decode(strInput : string): string;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  idpop31.Host:='A';
  idpop31.Port:=110;
  idpop31.Username:='b';
  idpop31.Password:='KX';
  idpop31.Connect;
  label1.Caption:='su\';
   button1.Visible:=false;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  button1.Visible:=true;
end;

procedure TForm1.Button2Click(Sender: TObject);  //H
var
  i, mcount : integer;
  li: TListItem;
begin
  listview1.Clear;
  mcount := IdPOP31.CheckMessages;
  if mcount > 0 then
    for i := 1 to mcount do
      begin
      IdMessage1.Clear;
      IdPOP31.RetrieveHeader(i, IdMessage1);
      li := ListView1.Items.Add;
      li.ImageIndex := 5;
      li.Caption := Base64Decode(IdMessage1.Subject);
      li.SubItems.Add(IdMessage1.From.Text);
      li.SubItems.Add(TimeToStr(IdMessage1.date));
      li.SubItems.Add(InttoStr(
        IdPOP31.RetrieveMsgSize(i) div 1024) + 'k');
      end
  else showmessage('HcSl');
end;

procedure TForm1.Button4Click(Sender: TObject);    //d\e
var
  i : integer;
  li : TListItem;
 
begin
  idmessage1.ContentType:='html';
  richedit1.Lines.Clear;  //H󤺮eM
  IdMessage1.Clear;
  IdPOP31.Retrieve(ListView1.Selected.Index + 1, IdMessage1);
  edit1.Text:=base64decode(idmessage1.From.Text);
  edit2.Text:=datetostr(idmessage1.Date);
  edit3.Text:=base64decode(idmessage1.Subject);
  RichEdit1.Text:= IdMessage1.Body.Text; //H󤺮e
  for i := 0 to Pred(IdMessage1.MessageParts.Count) do
    begin
    if (IdMessage1.MessageParts.Items[i] is TIdAttachment) then
      begin
      ListView2.Clear;
      li := (ListView2.Items.Add);
      li.Caption :=TIdAttachment(IdMessage1.MessageParts.Items[i]).FileName;
      li.ImageIndex := 7;
      end
    else
      begin
      if IdMessage1.MessageParts.Items[i] is TIdText then
        begin
        RichEdit1.Clear;
        RichEdit1.Lines.AddStrings(TIdText(IdMessage1.MessageParts.Items[i]).Body);

        end;

      end;
    end;
end;

procedure TForm1.down(Sender: TObject);   //U
var
  a:integer;
begin
  label2.Caption:='U';
end;

function TForm1.Base64Decode(strInput : string) : string;   //BzýX
var
    strDecode : string;
    posStart: Integer;
    posEnd : Integer;
begin
    while pos('=?big5?b?',lowercase(strInput)) > 0 do
    begin
    try
    posStart := pos('=?big5?b?',lowercase(strInput));
    posEnd := pos('?=',lowercase(strInput));
    strDecode := strDecode + copy(strInput,1,posStart-1) + IdDeMIME.DecodeString(copy(strInput,posStart+9,posEnd-posStart-9));

    strInput := copy(strInput,posEnd+2,length(strInput)-posEnd-1);
    finally
    Application.ProcessMessages;
    end;
    end;
    strDecode := strDecode + strInput;
    result := strDecode;
end;
end.
